require 'helpers'

local Scene = {}

function Scene:new()
    return new(Scene, {
        children = {}
    })
end

function Scene:finish()
    if self.manager then
        self.manager:finish_scene()
    end
end

function Scene:draw()
    for _, child in ipairs(self.children) do
        child:draw(self.x, self.y)
    end
end

function Scene:update(dt)
    for _, child in ipairs(self.children) do
        child:update(dt)
    end
end

function Scene:start_scene(child)
    child.manager = self

    push(self.children, child)
end

function Scene:finish_scene(n)
    remove(self.children, #self.children+(n or 0))
end

return Scene
