require 'helpers'

local SceneManager = {}

function SceneManager:new()
    return new(SceneManager, {
        stack = {}
    })
end

function SceneManager:finish_scene()
    remove(self.stack, #self.stack)
end

function SceneManager:start_scene(scene)
    scene.manager = self

    push(self.stack, scene)
end

function SceneManager:draw()
    local scene = last(self.stack)

    if scene then
        scene:draw()
    end
end

function SceneManager:update(dt)
    local scene = last(self.stack)

    if scene then
        scene:update(dt)
    end
end

return SceneManager
