require 'helpers'

local Arena = require 'arena'
PrepareHeroesScene = PrepareHeroesScene or require 'scenes.prepare_heroes'
GameOverScene = GameOverScene or require 'scenes.game_over'

CombatScene = new(require 'scene', {})

function CombatScene:new(p1, p2)
    p2:prepare_heroes_randomly()

    --player:remove_dead_heroes()
    --ai:remove_dead_heroes()

    --terminal_print('Before:')
    --terminal_print(a.name, a.vitality, a.strength, a.agility)

    --arena:battle()

    --terminal_print('After:')
    --terminal_print(a.name, a.vitality, a.strength, a.agility)

    local scene = new(CombatScene, {
        p1 = p1, p2 = p2,
        arena = Arena:new(p1, p2)
    })

    p1:remove_dead_heroes()
    p2:remove_dead_heroes()

    set_timeout(function()
        scene.arena:battle(function()
            scene:complete()
        end)
    end, 2)

    return scene
end

function CombatScene:complete()
    self.p1:remove_dead_heroes()
    self.p2:remove_dead_heroes()

    self.p1:raise_caps()
    self.p2:raise_caps()

    self.p2.vitality = self.p1:all_vitality_points()

    if self.p1:all_vitality_points() < 2 then
        self.manager:opening()
    else
        self.manager:configuration(self.p1, self.p2)
    end
end

function CombatScene:draw(x, y)
    self.arena:draw(x, y)

    PrepareHeroesScene.draw_hearts(self)
end

function CombatScene:update(dt)
end

return CombatScene
