require 'helpers'

GameOverScene = new(require 'scene', {})

local Easing = require 'nibui.Easing'
local NOM = require 'nibui.NOM'

local start_button_width = 60

function GameOverScene:new(p1, p2)
    local nom = NOM:new({
        x = 0,
        y = 0,
        w = NOM.parent.w,
        h = NOM.parent.h,
        background = 0,

        {
            id = 'start',

            x = NOM.right-start_button_width-6,
            y = NOM.bottom-20-6,
            w = start_button_width, h = 20,
            background = {112, 16, 16, 16, 2, 14, 2, 3},
            content = 'Start',

            onenter = function(self)
                self.document.cursor.state = 'pointer'
                self.text_palette = 2
            end,
            onleave = function(self)
                self.document.cursor.state = 'default'
                self.text_palette = 0
            end,
            onclick = function(self)
                self.scene:onstart()
            end
        },
    }):use('cursor')

    local scene = new(GameOverScene, {
        nom = nom,
    })

    nom:init()

    nom:find('#start').scene = scene

    return scene
end

function GameOverScene:onstart()
    self:finish()
    self.manager:configuration()
end

function GameOverScene:draw()
    self.nom.root:set_dirty();
    self.nom:draw()
end

function GameOverScene:update(dt)
    self.nom:update(dt)
end

return GameOverScene
