local Scene = require 'scene'

local TowerScene = require 'scenes.tower'

local IntroScene = Scene:new()

function IntroScene:new()
    local intro = new(IntroScene, {
        stack = {
            nil,
            {144, 160, 64, 64, 0}, -- Pixeldelic
            {144, 96, 64, 64, 0}, -- Talbone,
        },

        begin_at = nil,
    })

    set_timeout(function() intro:next() end, 1)

    return intro
end

function IntroScene:next()
    self.begin_at = clock()

    remove(self.stack, 1)

    for i=1,15 do
        swap_colors(i, 1)
    end

    if #self.stack > 0 then
        set_timeout(function() self:next() end, 5)
    else
        for i=1,15 do
            swap_colors(i, i)
        end

        self:finish()

        local tower_scene = TowerScene:new()
        self.manager:start_scene(tower_scene)
        tower_scene:opening()
    end
end

function IntroScene:draw()
    clear(1)

    if self.begin_at then
        local speed = 12
        local t = math.min(math.floor((clock()-self.begin_at)*speed), 16)

        if clock()-self.begin_at < 4 then
            for i=1,15 do
                swap_colors(i, math.max(i-(16-t), 1))
            end
        else
            local t = math.min(math.floor((clock()-self.begin_at-4)*speed), 16)

            for i=1,15 do
                swap_colors(i, math.max(i-t, 1))
            end
        end
    end

    if self.stack[1] then
       custom_sprite((320-64)/2, (240-64)/2, unwrap(self.stack[1]))
    end
end

return IntroScene
