require 'helpers'

PrepareHeroesScene = new(require 'scene', {})
CombatScene = CombatScene or require 'scenes.combat'

local NOM = require 'nibui.NOM'
local Easing = require 'nibui.Easing'

local HeroManager = require 'ui.hero_manager'

function PrepareHeroesScene:new(p1, p2)
    if p1:all_dead() then
        p1:create_hero()
    end

    local instance = new(PrepareHeroesScene, { p1 = p1, p2 = p2 })

    local hero_manager = HeroManager:new{
        player = p1,
        onstart=function()
            instance:fight()
        end
    }

    local nom = hero_manager:nom():use('cursor')

    nom:init()

    instance.hero_manager = heromanager
    instance.nom = nom

    return instance
end

function PrepareHeroesScene:fight()
    self:finish()
    self.manager:combat(self.p1, self.p2)
end

function PrepareHeroesScene:draw_hearts()
    local gap = 4
    local w = 16
    local wgap = w+gap
    local x = gap

    local points = 0

    while x < 320-w do
        if self.p1.vitality-points >= 2 then
            sprite(x, gap, 5, 0)
            points += 2
        elseif self.p1.vitality-points >= 1 then
            sprite(x, gap, 6, 0)
            points += 1
        else
            sprite(x, gap, 7, 0)
        end

        x += wgap
    end
end

function PrepareHeroesScene:draw()
    self.nom.root:set_dirty()
    self.nom:draw()

    self:draw_hearts()
end

function PrepareHeroesScene:update(dt)
    self.nom:update(dt)
end

return PrepareHeroesScene
