local NOM = require 'nibui.NOM'
require 'nibui.Neact'

local Button = Neact.Component:new()

local BTN_NORMAL = {112, 16, 16, 16, 2, 14, 2, 3}

function Button:new(props)
   return new(Button, {
                 props = props
   })
end

function Button:render(state, props)
   return {
      x = props.x, y = props.y,
      w = props.w, h = props.h,
      background = BTN_NORMAL,

      content = props.text,

      onenter = function(self) self.document.cursor.state = 'pointer' self.text_palette = 1 end,
      onleave = function(self) self.document.cursor.state = 'default' self.text_palette = 0 end,
      onclick = function(el) if self.props.action then self.props.action() end return true end,
   }
end

return Button
