local NOM = require 'nibui.NOM'
require 'nibui.Neact'

local CardStats = Neact.Component:new()

local HeroStat = require 'ui.hero_stat'

function CardStats:new(props)
   return new(CardStats, {
                 props = props
   })
end

function CardStats:render(state, props)
   local margin_top = 16
   local height = 3 * 20

   local pad = 12

   return {
      id = 'stats',

      x = NOM.left, y = NOM.bottom_of('picture')+margin_top,
      w = NOM.parent.w, h = height,

      {
         x = NOM.left+pad, y = NOM.top,
         w = NOM.parent.w-2*pad, h = NOM.parent.h,

         {HeroStat, hero = props.hero, stat = 'vitality', color = 0, n = 0},
         {HeroStat, hero = props.hero, stat = 'strength', color = 1, n = 1},
         {HeroStat, hero = props.hero, stat = 'agility', color = 2, n = 2},
      }
   }
end

return CardStats
