local NOM = require 'nibui.NOM'
require 'nibui.Neact'

local HeroManager = Neact.Component:new()

local Hero = require 'hero'
local HeroCard = require 'ui.hero_card'
local Button = require 'ui.button'

function HeroManager:new(props)
    return new(HeroManager, {
                 state = {
                     party = props.player.party,
                 },
                 props = props,
    })
end

function HeroManager:close_all()
    for _, card in ipairs(self.hero_cards) do
        card:close()
    end
end

function HeroManager:render(state, props)
    local top_pad = 6
    local left_pad = 6
    local space = 22

    local cards = {
        x = NOM.left, y = NOM.top,
        w = NOM.parent.w, h = NOM.parent.h,

        {Button, text = 'New',
         x = NOM.right-NOM.parent.w/2+left_pad, w = 60,
         y = NOM.bottom-20-top_pad, h = 20,
         action = function() props.player:create_hero() self:set_state(self.state) end},

        {Button, text = 'Fight',
         x = NOM.right-60-top_pad, w = 60,
         y = NOM.bottom-20-left_pad, h = 20,
         action = function() props.onstart() end},

    }

    self.hero_cards = {}

    for h, hero in ipairs(state.party) do
        push(cards, {HeroCard,
                     ref = function(card) push(self.hero_cards, card) end,
                     id = hero,
                     hero=hero,
                     manager=self,
                     x = NOM.left+left_pad,
                     y = NOM.top+top_pad+(h)*space})
    end

    return cards
end

return HeroManager
