local NOM = require 'nibui.NOM'
require 'nibui.Neact'

local HeroStat = Neact.Component:new()

local SmallButton = require 'ui.small_button'
local ProgressBar = require 'ui.progress_bar'

function HeroStat:new(props)
   return new(HeroStat, {
                 props = props
   })
end

function HeroStat:render(state, props)
   local height = 20
   local pad = 2

   return {
      x = NOM.left, y = NOM.top+(height+pad)*props.n,
      w = NOM.parent.w, h = height,

      {SmallButton, side='left', action = function()
          props.hero:change_stat(props.stat, -1)
      end},
      {
         x = NOM.left+SmallButton.width+pad,
         y = NOM.top,
         w = NOM.parent.w-(SmallButton.width+pad)*2,
         h = NOM.parent.h,

         {ProgressBar, color = props.color,
                       table = props.hero,
                       key = props.stat,
                       max = props.stat..'_cap',
                       mode = 'ratio'}
      },
      {SmallButton, side='right', action = function()
          props.hero:change_stat(props.stat, 1)
      end},
   }
end

return HeroStat
