local NOM = require('nibui.NOM')
local Widget = require('nibui.Widget')

local BTN_PREV = {120, 64, 8, 16}
local BTN_NEXT = {112, 64, 8, 16}
local PROGRESS_BAR = {80, 48, 48, 16, 4, 44, 7, 8}

return {
    background = 0, value = 0, color = 0;

    draw = function(self)
        if self.dirty then
            for _, widget in ipairs(self.children) do
                widget:draw()
            end
        end
    end;

    {
        background = 0,
        x = NOM.left+12, y = NOM.top,
        w = NOM.parent.w-24, h = NOM.parent.h,

        draw = function(self)
            if self.dirty then
                local var = self.parent.var

                clip(self.x, self.y, self.w, self.h)

                local ratio = (var and var.obj[var.key]/self.parent.max) or 0

                local w = math.floor(self.w*ratio/3)*3

                Widget.draw_9slice(self, self.x, self.y, self.w, self.h, unwrap(PROGRESS_BAR))

                for i=0, 10 do
                   Widget.draw_9slice(self, self.x+2, self.y+4, w-4, self.h-8, self.parent.color*2, 89, 3, 8, 0, 3, 2, 3)
                end

                self.content = self.parent.content.." "..tostring(var and var.obj[var.key])

                Widget.draw(self)
            end
        end
    },
    {
        x = NOM.left+4, y = NOM.top+2,
        w = 8, h = 16,

        background = BTN_PREV,

        onenter = function(self)
            self.document.cursor.state = 'pointer'
        end,
        onleave = function(self)
            self.document.cursor.state = 'default'
        end,
        onclick = function(self)
            if self.parent.sub then
                self.parent.sub[1]()
                self.parent:set_dirty()
            end

            return true
        end
    },
    {
        x = NOM.right-12, y = NOM.top+2,
        w = 8, h = 16,

        background = BTN_NEXT,

        onenter = function(self)
            self.document.cursor.state = 'pointer'
        end,
        onleave = function(self)
            self.document.cursor.state = 'default'
        end,
        onclick = function(self)
            if self.parent.add then
                self.parent.add[1]()
                self.parent:set_dirty()
            end

            return true
        end
    }
}
