local NOM = require 'nibui.NOM'
require 'nibui.Neact'

local SmallButton = Neact.Component:new()

local BTN_PREV = {120, 68, 8, 9}
local BTN_NEXT = {112, 68, 8, 9}

SmallButton.width = 8*2
SmallButton.height = 9*2
SmallButton.repeat_time = 0.2

function SmallButton:new(props)
   return new(SmallButton, {
                 props = props
   })
end

function SmallButton:render(state, props)
   local width = SmallButton.width
   local height = SmallButton.height
   local x
   local bg

   if props.side == 'right' then
      x = NOM.right-width
      bg = BTN_NEXT
   else
      x = NOM.left
      bg = BTN_PREV
   end

   local function repeat_press()
      if self.pressed then
         self.repeat_pressed = true

         if self.props.action then
            self.props.action()
         end

         set_timeout(repeat_press, SmallButton.repeat_time)

         return true
      end
   end

   return {
      x = x, y = NOM.top,
      w = width, h = NOM.parent.h,

      {
          x = NOM.left+(NOM.parent.w-8)/2, y = NOM.top+(NOM.parent.h-9)/2,
          w = 8, h = 9,

          background = bg,
      },

      onenter = function(self) self.document.cursor.state = 'pointer' self.children[1].palette = 1 end,
      onleave = function(el) self.pressed = false el.document.cursor.state = 'default' el.children[1].palette = 0 end,
      onclick = function(el) self.pressed = false if not self.repeat_pressed and self.props.action then self.props.action() end return true end,
      onpress = function(el) self.el = el self.pressed = true self.repeat_pressed = false set_timeout(repeat_press, SmallButton.repeat_time) end,
   }
end

return SmallButton
